﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using OnSite.ClickerAce.Plugin;
using OnSite.ClickerAce.Plugin.Interfaces;
using System.Reflection;
using System.Windows.Forms;

namespace $safeprojectname$ {
  public class Plugin : PluginBase<PluginRecord>, IAddablePlugin {

    public override string Title => "$projectname$";

    public override PluginVersion Version => new PluginVersion(1, 0, 0);

    public override PluginVersion SupportedMinimumVersion => new PluginVersion(1, 0, 0);

    public override ImageSource SmallIcon { get; } = new BitmapImage(new Uri($"pack://application:,,,/{Assembly.GetExecutingAssembly().GetName()};component/Assets/Icon.png"));

    public override ImageSource Icon { get; } = new BitmapImage(new Uri($"pack://application:,,,/{Assembly.GetExecutingAssembly().GetName()};component/Assets/Icon.png"));

    public override ImageSource LargeIcon { get; } = new BitmapImage(new Uri($"pack://application:,,,/{Assembly.GetExecutingAssembly().GetName()};component/Assets/Icon.png"));

    public string EditControlName => typeof(Views.EditView).FullName;

    public override bool Action(IOperateParameter parameter) {
      if (parameter.Record is PluginRecord rec) {
        MessageBox.Show(rec.SampleValue);
      }
      return true;
    }

  }
}
