﻿using OnSite.ClickerAce.Plugin.ViewModels;
using Prism.Commands;
using Prism.Mvvm;
using Prism.Services.Dialogs;
using System;
using System.Collections.Generic;
using System.Linq;

namespace $safeprojectname$.ViewModels {
  public class EditViewModel : EditDialogBaseViewModel<PluginRecord> {

    public EditViewModel() {
    }

    private string _inputValue;
    public string InputValue {
      get => _inputValue;
      set => SetProperty(ref _inputValue, value);
    }

    public override void OnDialogOpened(IDialogParameters parameters) {
      base.OnDialogOpened(parameters);
      if (!IsNew) {
        if (Value == null) throw new ArgumentNullException();
        this.InputValue = Value.SampleValue;
      }
    }

    protected override PluginRecord Apply() {
      var rec = new PluginRecord {
        SampleValue = InputValue
      };
      return rec;
    }

  }
}
